# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.Control do
  @moduledoc """
  Selects and configures the service controller used by the service. Example: control: environment: servicecontrol.googleapis.com

  ## Attributes

  *   `environment` (*type:* `String.t`, *default:* `nil`) - The service controller environment to use. If empty, no control plane feature (like quota and billing) will be enabled. The recommended value for most services is servicecontrol.googleapis.com
  *   `methodPolicies` (*type:* `list(GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy.t)`, *default:* `nil`) - Defines policies applying to the API methods of the service.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :environment => String.t() | nil,
          :methodPolicies =>
            list(GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy.t()) | nil
        }

  field(:environment)

  field(:methodPolicies,
    as: GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.Control do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.Control.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.Control do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
