# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.ListTenancyUnitsResponse do
  @moduledoc """
  Response for the list request.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Pagination token for large results.
  *   `tenancyUnits` (*type:* `list(GoogleApi.ServiceConsumerManagement.V1.Model.TenancyUnit.t)`, *default:* `nil`) - Tenancy units matching the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :tenancyUnits =>
            list(GoogleApi.ServiceConsumerManagement.V1.Model.TenancyUnit.t()) | nil
        }

  field(:nextPageToken)
  field(:tenancyUnits, as: GoogleApi.ServiceConsumerManagement.V1.Model.TenancyUnit, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.ListTenancyUnitsResponse do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.ListTenancyUnitsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.ListTenancyUnitsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
