# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy do
  @moduledoc """
  Defines policies applying to an RPC method.

  ## Attributes

  *   `requestPolicies` (*type:* `list(GoogleApi.ServiceConsumerManagement.V1.Model.FieldPolicy.t)`, *default:* `nil`) - Policies that are applicable to the request message.
  *   `selector` (*type:* `String.t`, *default:* `nil`) - Selects a method to which these policies should be enforced, for example, "google.pubsub.v1.Subscriber.CreateSubscription". Refer to selector for syntax details. NOTE: This field must not be set in the proto annotation. It will be automatically filled by the service config compiler .
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :requestPolicies =>
            list(GoogleApi.ServiceConsumerManagement.V1.Model.FieldPolicy.t()) | nil,
          :selector => String.t() | nil
        }

  field(:requestPolicies,
    as: GoogleApi.ServiceConsumerManagement.V1.Model.FieldPolicy,
    type: :list
  )

  field(:selector)
end

defimpl Poison.Decoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.MethodPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
