# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.TenantResource do
  @moduledoc """
  Resource constituting the TenancyUnit.

  ## Attributes

  *   `resource` (*type:* `String.t`, *default:* `nil`) - Output only. @OutputOnly Identifier of the tenant resource. For cloud projects, it is in the form 'projects/{number}'. For example 'projects/123456'.
  *   `status` (*type:* `String.t`, *default:* `nil`) - Status of tenant resource.
  *   `tag` (*type:* `String.t`, *default:* `nil`) - Unique per single tenancy unit.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resource => String.t() | nil,
          :status => String.t() | nil,
          :tag => String.t() | nil
        }

  field(:resource)
  field(:status)
  field(:tag)
end

defimpl Poison.Decoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.TenantResource do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.TenantResource.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.TenantResource do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
