# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.UsageRule do
  @moduledoc """
  Usage configuration rules for the service. NOTE: Under development. Use this rule to configure unregistered calls for the service. Unregistered calls are calls that do not contain consumer project identity. (Example: calls that do not contain an API key). By default, API methods do not allow unregistered calls, and each method call must be identified by a consumer project identity. Use this rule to allow/disallow unregistered calls. Example of an API that wants to allow unregistered calls for entire service. usage: rules: - selector: "*" allow_unregistered_calls: true Example of a method that wants to allow unregistered calls. usage: rules: - selector: "google.example.library.v1.LibraryService.CreateBook" allow_unregistered_calls: true

  ## Attributes

  *   `allowUnregisteredCalls` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method allows unregistered calls, e.g. calls that don't identify any user or application.
  *   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Use '*' to indicate all methods in all APIs. Refer to selector for syntax details.
  *   `skipServiceControl` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method should skip service control and the control plane features, such as quota and billing, will not be available. This flag is used by Google Cloud Endpoints to bypass checks for internal methods, such as service health check methods.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :allowUnregisteredCalls => boolean() | nil,
          :selector => String.t() | nil,
          :skipServiceControl => boolean() | nil
        }

  field(:allowUnregisteredCalls)
  field(:selector)
  field(:skipServiceControl)
end

defimpl Poison.Decoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.UsageRule do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.UsageRule.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ServiceConsumerManagement.V1.Model.UsageRule do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
