# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1GenerateServiceIdentityResponse do
  @moduledoc """
  Response message for the `GenerateServiceIdentity` method. This response message is assigned to the `response` field of the returned Operation when that operation is done.

  ## Attributes

  *   `identity` (*type:* `GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1ServiceIdentity.t`, *default:* `nil`) - ServiceIdentity that was created or retrieved.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :identity =>
            GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1ServiceIdentity.t() | nil
        }

  field(:identity, as: GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1ServiceIdentity)
end

defimpl Poison.Decoder,
  for: GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1GenerateServiceIdentityResponse do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1GenerateServiceIdentityResponse.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.ServiceConsumerManagement.V1.Model.V1Beta1GenerateServiceIdentityResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
