# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ServiceConsumerManagement.V1.Model.V1GenerateDefaultIdentityResponse do
  @moduledoc """
  Response message for the `GenerateDefaultIdentity` method. This response message is assigned to the `response` field of the returned Operation when that operation is done.

  ## Attributes

  *   `attachStatus` (*type:* `String.t`, *default:* `nil`) - Status of the role attachment. Under development (go/si-attach-role), currently always return ATTACH_STATUS_UNSPECIFIED)
  *   `identity` (*type:* `GoogleApi.ServiceConsumerManagement.V1.Model.V1DefaultIdentity.t`, *default:* `nil`) - DefaultIdentity that was created or retrieved.
  *   `role` (*type:* `String.t`, *default:* `nil`) - Role attached to consumer project. Empty if not attached in this request. (Under development, currently always return empty.)
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attachStatus => String.t() | nil,
          :identity => GoogleApi.ServiceConsumerManagement.V1.Model.V1DefaultIdentity.t() | nil,
          :role => String.t() | nil
        }

  field(:attachStatus)
  field(:identity, as: GoogleApi.ServiceConsumerManagement.V1.Model.V1DefaultIdentity)
  field(:role)
end

defimpl Poison.Decoder,
  for: GoogleApi.ServiceConsumerManagement.V1.Model.V1GenerateDefaultIdentityResponse do
  def decode(value, options) do
    GoogleApi.ServiceConsumerManagement.V1.Model.V1GenerateDefaultIdentityResponse.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.ServiceConsumerManagement.V1.Model.V1GenerateDefaultIdentityResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
